<template>
  <div>
    <div v-if="$apollo.loading">Loading...</div>
    <v-form>
      <v-container>
        <v-row>
          <v-col cols="12" md="4">
            <v-select
              :items="subjects"
              item-text="name"
              item-value="id"
              label="Subject"
              v-model="subject"
              type="number"
            ></v-select>
          </v-col>

          <v-col cols="12" md="4">
            <v-text-field
              v-model="message"
              :counter="10"
              label="Message"
              required
            ></v-text-field>
          </v-col>

          <v-col cols="12" md="4">
            <v-btn color="primary" @click="addContact">Save</v-btn>
          </v-col>
        </v-row>
      </v-container>
    </v-form>

    <v-simple-table>
      <template v-slot:default>
        <thead>
          <tr>
            <th class="text-left">#</th>
            <th class="text-left">Message</th>
            <th class="text-left">Subject</th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="item in contacts" :key="item.id">
            <td>{{ item.id }}</td>
            <td>{{ item.message }}</td>
            <td>{{ item.subject.name }}</td>
          </tr>
        </tbody>
      </template>
    </v-simple-table>
  </div>
</template>
<script lang="ts">
import Vue from 'vue'
import gql from 'graphql-tag'

const CONTACTS = gql(`
query AllContact($limit: Int!) {
  contacts(limit: $limit) {
    id,
    message,
    subject {
        code,
        name
    }
  }
}
`)

const AllSubjects = gql(`
query AllSubjects {
    subjects{
    id,
    name
  }
}
`)

const ADD_CONTACT = gql(`
mutation AddContact($input: NewContactInput!) {
    addContact(newContactData: $input) {
      message
    }
  }
`)

export default Vue.extend({
  data: () => ({
    subject: '',
    message: '',
    limit: 100,
  }),
  apollo: {
    subjects: {
      // query: AllSubjects,
      query() {
        this.$data.limit
        return AllSubjects
      },
    },
    contacts: {
      query: CONTACTS,
      variables(): { limit: number } {
        return {
          limit: this.limit,
        }
      },
    },
  },
  methods: {
    async addContact() {
      try {
        await this.$apollo.mutate({
          mutation: ADD_CONTACT,
          refetchQueries: [
            {
              query: CONTACTS,
              variables: {
                limit: this.limit,
              },
            },
          ],
          variables: {
            input: {
              subject: parseInt(this.subject),
              message: this.$data.message,
            },
          },
        })
      } catch (e) {
        console.log(e)
      }
    },
  },
})
</script>